module.exports = (grunt) ->


    grunt.loadNpmTasks 'grunt-contrib-concat'
    grunt.loadNpmTasks 'grunt-contrib-uglify'
    grunt.loadNpmTasks 'grunt-contrib-coffee'
    grunt.loadNpmTasks 'grunt-contrib-less'
    grunt.loadNpmTasks 'grunt-contrib-watch'

    grunt.registerTask 'default', ['coffee','less','concat','uglify']

    grunt.initConfig

        #watch and compile all folders separately for the quickest compile time
        watch:
            src:
                files: 'src/**/*.coffee'
                tasks: ['coffee:src', 'concat:js', 'uglify:js']

            styles:
                files: 'styles/**/*.less'
                tasks: ['less:styles', 'concat:css']


        coffee:
            src:
                expand: true
                cwd: 'src/'
                src: ['**/*.coffee']
                dest: 'gen/js/src'
                ext: '.js'

        less:
            styles:
                options:
                    yuicompress: true

                files:
                    "gen/styles/widget.css": "styles/*.less"


        concat:
            js:
                src: [
                    'lib/jquery.storage.js'
                    'gen/js/src/plugin.js'
                    'gen/js/src/markup.js'
                    'gen/js/src/component.js'
                ]
                dest: 'dist/betaq-widget.js'

            css:
                src: ['gen/styles/*.css']
                dest: 'dist/betaq-widget.css'


        uglify:
            js:
                files:
                    'dist/betaq-widget.min.js' : 'dist/betaq-widget.js'
