do ($ = jQuery) ->

    $.fn.betaQ._BetaQ = class BetaQ

        localStorageKey: 'betaq.userdata'

        constructor: ({@apiUrl, @apiVersion, @appId, @whenUserWelcomed, @facebookShareUrl, @twitterShareUrl, @$el}) ->

            @render()

            userData = $.localStorage(@localStorageKey)
            if userData
                $.ajax("#{@apiUrl}api/#{@apiVersion}/app/#{@appId}/user/#{userData.token}", {
                    dataType: 'jsonp'
                }).done (serverUserData) =>
                    $.localStorage 'betaq.userdata', {
                        ahead: serverUserData.ahead
                        behind: serverUserData.behind
                        hash: serverUserData.hash
                        token: serverUserData.token
                    }
                    if serverUserData.hasAccess && serverUserData.userWelcomed
                        @whenUserWelcomed()
                    else if serverUserData.hasAccess && !serverUserData.userWelcomed
                        @showWelcome()
                    else
                        @showYourSpot serverUserData

            else
                @showGlobalStats()


        showGlobalStats: ->
            $.ajax("#{@apiUrl}api/#{@apiVersion}/app/#{@appId}", {
                dataType: 'jsonp'
            }).done (waitingListData) =>
                ahead = waitingListData.numInLineTotal - waitingListData.numLetIn
                
                $('.numberInFront', @$el).html(ahead).show()
                
                $('.textInFront', @$el).html("#{@_pluralizePeople(ahead)} in front of you").show()

                $('.saveYourSpot', @$el).show()

                $('.gravatar', @$el).hide()

                $('.numberBehind', @$el).hide()

                $('.welcome', @$el).hide()

                $('.share', @$el).hide()

                $('.signInAsSomeoneElse', @$el).hide()

        saveYourSpot: (e) ->
            return if e.keyCode and e.keyCode != 13

            email = $('.saveYourSpot input').val()
            regex = /^([a-zA-Z0-9_\.\-\+])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/
            if not regex.test email
                $('.alert', @$el).show()
                return
            
            promise = $.ajax "#{@apiUrl}api/#{@apiVersion}/app/#{@appId}/user/create",
                dataType: 'jsonp'
                data:
                    email: email

            promise.done (userData) =>
                $.localStorage 'betaq.userdata', {
                    ahead: userData.ahead
                    behind: userData.behind
                    hash: userData.hash
                    token: userData.token
                }

                if userData.hasAccess && userData.userWelcomed
                    @whenUserWelcomed()
                else if userData.hasAccess && !userData.userWelcomed
                    @showWelcome()
                else
                    @showYourSpot userData

        showWelcome: ->

            $('.betaqWaitingList .tile > div ').hide()

            $('.betaqWaitingList .tile > .signInAsSomeoneElse ').show()
            $('.betaqWaitingList .tile > .welcome ').show()


        userWelcomed: (e) ->
            userData = $.localStorage(@localStorageKey)

            promise = $.ajax "#{@apiUrl}api/#{@apiVersion}/app/#{@appId}/user/#{userData.token}/welcome",
                dataType: 'jsonp'

            promise.done (userData) =>
                @whenUserWelcomed()

        showYourSpot: ({ahead, behind, hash, token}) ->

            $('.numberInFront', @$el).html(ahead)

            $('.saveYourSpot', @$el).hide()

            $('.gravatar', @$el).html("<img src='http://gravatar.com/avatar/#{hash}?d=mm'/>").show()

            $('.numberBehind', @$el).html("#{behind} behind you").show()

            $('.share .facebook > a').attr('href', "https://www.facebook.com/share.php?u=#{encodeURIComponent(@facebookShareUrl)}")
            $('.share .twitter > a').attr('href', "https://www.twitter.com/intent/tweet?url=#{encodeURIComponent(@twitterShareUrl)}")
            $('.share', @$el).show()

            $('.signInAsSomeoneElse', @$el).show()

        forgetUser: ->
            $.localStorage 'betaq.userdata', null
            @showGlobalStats()

        render: ->
            html = $.fn.betaQ._markup

            @$el.html html

            $('.saveYourSpot button.saveYourSpotBtn', @$el).on 'click', (e) => @saveYourSpot(e)
            $('.saveYourSpot input', @$el).on 'keyup', (e) => @saveYourSpot(e)
            $('.alert button.close', @$el).on 'click', => @_hideAlert()
            $('.signInAsSomeoneElse a', @$el).on 'click', => @forgetUser()
            $('.welcome button.letMeInBtn', @$el).on 'click', (e) => @userWelcomed(e)


        _pluralizePeople: (count) ->
            if count == 1 then 'person' else 'people'

        _hideAlert: ->
            $('.alert', @$el).hide()
